Index: serefpolicy-contrib-20140730/mta.if
===================================================================
--- serefpolicy-contrib-20140730.orig/mta.if
+++ serefpolicy-contrib-20140730/mta.if
@@ -1,4 +1,4 @@
-## <summary>Common e-mail transfer agent policy.</summary>
+## <summary>Policy common to all email tranfer agents.</summary>
 
 ########################################
 ## <summary>
@@ -18,23 +18,37 @@ interface(`mta_stub',`
 
 #######################################
 ## <summary>
-##	The template to define a mail domain.
+##	Basic mail transfer agent domain template.
 ## </summary>
+## <desc>
+##	<p>
+##	This template creates a derived domain which is
+##	a email transfer agent, which sends mail on
+##	behalf of the user.
+##	</p>
+##	<p>
+##	This is the basic types and rules, common
+##	to the system agent and user agents.
+##	</p>
+## </desc>
 ## <param name="domain_prefix">
 ##	<summary>
-##	Domain prefix to be used.
+##	The prefix of the domain (e.g., user
+##	is the prefix for user_t).
 ##	</summary>
 ## </param>
+## <rolecap/>
 #
 template(`mta_base_mail_template',`
+
 	gen_require(`
 		attribute user_mail_domain;
 		type sendmail_exec_t;
 	')
 
-	########################################
+	##############################
 	#
-	# Declarations
+	# $1_mail_t declarations
 	#
 
 	type $1_mail_t, user_mail_domain;
@@ -43,17 +57,18 @@ template(`mta_base_mail_template',`
 	type $1_mail_tmp_t;
 	files_tmp_file($1_mail_tmp_t)
 
-	########################################
-	#
-	# Declarations
-	#
-
 	manage_dirs_pattern($1_mail_t, $1_mail_tmp_t, $1_mail_tmp_t)
 	manage_files_pattern($1_mail_t, $1_mail_tmp_t, $1_mail_tmp_t)
 	files_tmp_filetrans($1_mail_t, $1_mail_tmp_t, { file dir })
 
+	kernel_read_system_state($1_mail_t)
+
+	corenet_all_recvfrom_netlabel($1_mail_t)
+
 	auth_use_nsswitch($1_mail_t)
 
+	logging_send_syslog_msg($1_mail_t)
+
 	optional_policy(`
 		postfix_domtrans_user_mail_handler($1_mail_t)
 	')
@@ -61,61 +76,41 @@ template(`mta_base_mail_template',`
 
 ########################################
 ## <summary>
-##	Role access for mta.
+##	Role access for mta
 ## </summary>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	Role allowed access
 ##	</summary>
 ## </param>
 ## <param name="domain">
 ##	<summary>
-##	User domain for the role.
+##	User domain for the role
 ##	</summary>
 ## </param>
 #
 interface(`mta_role',`
 	gen_require(`
 		attribute mta_user_agent;
-		attribute_role user_mail_roles;
-		type user_mail_t, sendmail_exec_t, mail_home_t;
-		type user_mail_tmp_t, mail_home_rw_t;
+		type user_mail_t, sendmail_exec_t;
 	')
 
-	roleattribute $1 user_mail_roles;
-
-	# this is something i need to fix
-	# i dont know if and why it is needed
-	# will role attribute work?
-	role $1 types mta_user_agent;
+	role $1 types { user_mail_t mta_user_agent };
 
+	# Transition from the user domain to the derived domain.
 	domtrans_pattern($2, sendmail_exec_t, user_mail_t)
 	allow $2 sendmail_exec_t:lnk_file read_lnk_file_perms;
 
-	allow $2 { user_mail_t mta_user_agent }:process { ptrace signal_perms };
-	ps_process_pattern($2, { user_mail_t mta_user_agent })
-
-	allow $2 mail_home_t:file { manage_file_perms relabel_file_perms };
-	userdom_user_home_dir_filetrans($2, mail_home_t, file, ".esmtp_queue")
-	userdom_user_home_dir_filetrans($2, mail_home_t, file, ".forward")
-	userdom_user_home_dir_filetrans($2, mail_home_t, file, ".mailrc")
-	userdom_user_home_dir_filetrans($2, mail_home_t, file, "dead.letter")
-
-	allow $2 mail_home_rw_t:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 mail_home_rw_t:file { manage_file_perms relabel_file_perms };
-	allow $2 mail_home_rw_t:lnk_file { manage_lnk_file_perms relabel_lnk_file_perms };
-	userdom_user_home_dir_filetrans($2, mail_home_rw_t, dir, "Maildir")
-	userdom_user_home_dir_filetrans($2, mail_home_rw_t, dir, ".maildir")
-
-	allow $2 user_mail_tmp_t:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 user_mail_tmp_t:file { manage_file_perms relabel_file_perms };
+	allow mta_user_agent $2:fd use;
+	allow mta_user_agent $2:process sigchld;
+	allow mta_user_agent $2:fifo_file rw_inherited_fifo_file_perms;
 
 	optional_policy(`
 		exim_run($2, $1)
 	')
 
 	optional_policy(`
-		mailman_run($2, $1)
+		mailman_run(mta_user_agent, $1)
 	')
 ')
 
@@ -163,125 +158,23 @@ interface(`mta_agent_executable',`
 	application_executable_file($1)
 ')
 
-#######################################
-## <summary>
-##	Read mta mail home files.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`mta_read_mail_home_files',`
-	gen_require(`
-		type mail_home_t;
-	')
-
-	userdom_search_user_home_dirs($1)
-	allow $1 mail_home_t:file read_file_perms;
-')
-
-#######################################
-## <summary>
-##	Create, read, write, and delete
-##	mta mail home files.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`mta_manage_mail_home_files',`
-	gen_require(`
-		type mail_home_t;
-	')
-
-	userdom_search_user_home_dirs($1)
-	allow $1 mail_home_t:file manage_file_perms;
-')
-
-########################################
+######################################
 ## <summary>
-##	Create specified objects in user home
-##	directories with the generic mail
-##	home type.
+##  Dontaudit read and write an leaked file descriptors
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
-##	<summary>
-##	The name of the object being created.
-##	</summary>
-## </param>
-#
-interface(`mta_home_filetrans_mail_home',`
-	gen_require(`
-		type mail_home_t;
-	')
-
-	userdom_user_home_dir_filetrans($1, mail_home_t, $2, $3)
-')
-
-#######################################
-## <summary>
-##	Create, read, write, and delete
-##	mta mail home rw content.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`mta_manage_mail_home_rw_content',`
-	gen_require(`
-		type mail_home_rw_t;
-	')
-
-	userdom_search_user_home_dirs($1)
-	manage_dirs_pattern($1, mail_home_rw_t, mail_home_rw_t)
-	manage_files_pattern($1, mail_home_rw_t, mail_home_rw_t)
-	manage_lnk_files_pattern($1, mail_home_rw_t, mail_home_rw_t)
-')
-
-########################################
-## <summary>
-##	Create specified objects in user home
-##	directories with the generic mail
-##	home rw type.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
-##	<summary>
-##	The name of the object being created.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`mta_home_filetrans_mail_home_rw',`
+interface(`mta_dontaudit_leaks_system_mail',`
 	gen_require(`
-		type mail_home_rw_t;
+		type system_mail_t;
 	')
 
-	userdom_user_home_dir_filetrans($1, mail_home_rw_t, $2, $3)
+	dontaudit $1 system_mail_t:fifo_file write;
+	dontaudit $1 system_mail_t:tcp_socket { read write };
 ')
 
 ########################################
@@ -334,7 +227,6 @@ interface(`mta_sendmail_mailserver',`
 	')
 
 	init_system_domain($1, sendmail_exec_t)
-
 	typeattribute $1 mailserver_domain;
 ')
 
@@ -374,6 +266,15 @@ interface(`mta_mailserver_delivery',`
 	')
 
 	typeattribute $1 mailserver_delivery;
+
+	userdom_home_manager($1)
+
+	optional_policy(`
+		mta_rw_delivery_tcp_sockets($1)
+	')
+
+	userdom_filetrans_home_content($1)
+
 ')
 
 #######################################
@@ -394,6 +295,12 @@ interface(`mta_mailserver_user_agent',`
 	')
 
 	typeattribute $1 mta_user_agent;
+
+	optional_policy(`
+		# apache should set close-on-exec
+		apache_dontaudit_rw_stream_sockets($1)
+		apache_dontaudit_rw_sys_script_stream_sockets($1)
+	')
 ')
 
 ########################################
@@ -408,14 +315,19 @@ interface(`mta_mailserver_user_agent',`
 #
 interface(`mta_send_mail',`
 	gen_require(`
+		attribute mta_user_agent;
 		type system_mail_t;
 		attribute mta_exec_type;
 	')
 
-	corecmd_search_bin($1)
+	allow $1 mta_exec_type:lnk_file read_lnk_file_perms;
+	corecmd_read_bin_symlinks($1)
 	domtrans_pattern($1, mta_exec_type, system_mail_t)
 
-	allow $1 mta_exec_type:lnk_file read_lnk_file_perms;
+	allow mta_user_agent $1:fd use;
+	allow mta_user_agent $1:process sigchld;
+	allow mta_user_agent $1:fifo_file rw_inherited_fifo_file_perms;
+	dontaudit mta_user_agent $1:unix_stream_socket rw_socket_perms;
 ')
 
 ########################################
@@ -445,18 +357,24 @@ interface(`mta_send_mail',`
 #
 interface(`mta_sendmail_domtrans',`
 	gen_require(`
-		type sendmail_exec_t;
+		attribute mta_exec_type;
+		attribute mta_user_agent;
 	')
 
-	corecmd_search_bin($1)
-	domain_auto_trans($1, sendmail_exec_t, $2)
+	files_search_usr($1)
+	allow $1 mta_exec_type:lnk_file read_lnk_file_perms;
+	corecmd_read_bin_symlinks($1)
 
-	allow $1 sendmail_exec_t:lnk_file read_lnk_file_perms;
+	allow $2 mta_exec_type:file entrypoint;
+	domtrans_pattern($1, mta_exec_type, $2)
+	allow mta_user_agent $1:fd use;
+	allow mta_user_agent $1:process sigchld;
+	allow mta_user_agent $1:fifo_file rw_inherited_fifo_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Send signals to system mail.
+##	Send system mail client a signal
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -464,7 +382,6 @@ interface(`mta_sendmail_domtrans',`
 ##	</summary>
 ## </param>
 #
-#
 interface(`mta_signal_system_mail',`
 	gen_require(`
 		type system_mail_t;
@@ -475,7 +392,43 @@ interface(`mta_signal_system_mail',`
 
 ########################################
 ## <summary>
-##	Send kill signals to system mail.
+##	Send all user mail client a signal
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`mta_signal_user_agent',`
+	gen_require(`
+		attribute mta_user_agent;
+	')
+
+	allow $1 mta_user_agent:process signal;
+')
+
+########################################
+## <summary>
+##	Send all user mail client a kill signal
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`mta_kill_user_agent',`
+	gen_require(`
+		attribute mta_user_agent;
+	')
+
+	allow $1 mta_user_agent:process sigkill;
+')
+
+########################################
+## <summary>
+##	Send system mail client a kill signal
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -506,13 +459,32 @@ interface(`mta_sendmail_exec',`
 		type sendmail_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	can_exec($1, sendmail_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	Read mail server configuration content.
+##	Check whether sendmail executable
+##	files are executable.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`mta_sendmail_access_check',`
+	gen_require(`
+		type sendmail_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	allow $1 sendmail_exec_t:file { getattr_file_perms execute };
+')
+
+########################################
+## <summary>
+##	Read mail server configuration.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -528,13 +500,13 @@ interface(`mta_read_config',`
 
 	files_search_etc($1)
 	allow $1 etc_mail_t:dir list_dir_perms;
-	allow $1 etc_mail_t:file read_file_perms;
-	allow $1 etc_mail_t:lnk_file read_lnk_file_perms;
+	read_files_pattern($1, etc_mail_t, etc_mail_t)
+	read_lnk_files_pattern($1, etc_mail_t, etc_mail_t)
 ')
 
 ########################################
 ## <summary>
-##	Write mail server configuration files.
+##	write mail server configuration.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -548,33 +520,31 @@ interface(`mta_write_config',`
 		type etc_mail_t;
 	')
 
-	files_search_etc($1)
 	write_files_pattern($1, etc_mail_t, etc_mail_t)
 ')
 
 ########################################
 ## <summary>
-##	Read mail address alias files.
+##	Manage mail server configuration.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
+## <rolecap/>
 #
-interface(`mta_read_aliases',`
+interface(`mta_manage_config',`
 	gen_require(`
-		type etc_aliases_t;
+		type etc_mail_t;
 	')
 
-	files_search_etc($1)
-	allow $1 etc_aliases_t:file read_file_perms;
+	manage_files_pattern($1, etc_mail_t, etc_mail_t)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	mail address alias content.
+##	Read mail address aliases.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -582,84 +552,66 @@ interface(`mta_read_aliases',`
 ##	</summary>
 ## </param>
 #
-interface(`mta_manage_aliases',`
+interface(`mta_read_aliases',`
 	gen_require(`
 		type etc_aliases_t;
 	')
 
 	files_search_etc($1)
-	manage_files_pattern($1, etc_aliases_t, etc_aliases_t)
-	manage_lnk_files_pattern($1, etc_aliases_t, etc_aliases_t)
+	allow $1 etc_aliases_t:file read_file_perms;
+	allow $1 etc_aliases_t:lnk_file read_lnk_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Create specified object in generic
-##	etc directories with the mail address
-##	alias type.
+##	Create, read, write, and delete mail address aliases.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="object">
-##	<summary>
-##	The object class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
-##	<summary>
-##	The name of the object being created.
-##	</summary>
-## </param>
 #
-interface(`mta_etc_filetrans_aliases',`
+interface(`mta_manage_aliases',`
 	gen_require(`
 		type etc_aliases_t;
 	')
 
-	files_etc_filetrans($1, etc_aliases_t, $2, $3)
+	files_search_etc($1)
+	manage_files_pattern($1, etc_aliases_t, etc_aliases_t)
+	manage_lnk_files_pattern($1, etc_aliases_t, etc_aliases_t)
+	mta_etc_filetrans_aliases($1, "aliases")
+	mta_etc_filetrans_aliases($1, "aliases.db")
+	mta_etc_filetrans_aliases($1, "aliasesdb-stamp")
 ')
 
 ########################################
 ## <summary>
-##	Create specified objects in specified
-##	directories with a type transition to
-##	the mail address alias type.
+##	Type transition files created in /etc
+##	to the mail address aliases type.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="file_type">
-##	<summary>
-##	Directory to transition on.
-##	</summary>
-## </param>
-## <param name="object">
-##	<summary>
-##	The object class of the object being created.
-##	</summary>
-## </param>
 ## <param name="name" optional="true">
 ##	<summary>
 ##	The name of the object being created.
 ##	</summary>
 ## </param>
 #
-interface(`mta_spec_filetrans_aliases',`
+interface(`mta_etc_filetrans_aliases',`
 	gen_require(`
 		type etc_aliases_t;
 	')
 
-	filetrans_pattern($1, $2, etc_aliases_t, $3, $4)
+	files_etc_filetrans($1, etc_aliases_t, file, $2)
 ')
 
 ########################################
 ## <summary>
-##	Read and write mail alias files.
+##	Read and write mail aliases.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -674,14 +626,13 @@ interface(`mta_rw_aliases',`
 	')
 
 	files_search_etc($1)
-	allow $1 etc_aliases_t:file rw_file_perms;
+	allow $1 etc_aliases_t:file { rw_file_perms setattr_file_perms };
 ')
 
 #######################################
 ## <summary>
-##	Do not audit attempts to read
-##	and write TCP sockets of mail
-##	delivery domains.
+##	Do not audit attempts to read and write TCP
+##	sockets of mail delivery domains.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -697,6 +648,25 @@ interface(`mta_dontaudit_rw_delivery_tcp
 	dontaudit $1 mailserver_delivery:tcp_socket { read write };
 ')
 
+######################################
+## <summary>
+##  Allow attempts to read and write TCP
+##  sockets of mail delivery domains.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain to not audit.
+##  </summary>
+## </param>
+#
+interface(`mta_rw_delivery_tcp_sockets',`
+    gen_require(`
+        attribute mailserver_delivery;
+    ')
+
+    allow $1 mailserver_delivery:tcp_socket { read write };
+')
+
 #######################################
 ## <summary>
 ##	Connect to all mail servers over TCP.  (Deprecated)
@@ -713,8 +683,8 @@ interface(`mta_tcp_connect_all_mailserve
 
 #######################################
 ## <summary>
-##	Do not audit attempts to read
-##	mail spool symlinks.
+##	Do not audit attempts to read a symlink
+##	in the mail spool.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -732,7 +702,7 @@ interface(`mta_dontaudit_read_spool_syml
 
 ########################################
 ## <summary>
-##	Get attributes of mail spool content.
+##	Get the attributes of mail spool files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -753,8 +723,8 @@ interface(`mta_getattr_spool',`
 
 ########################################
 ## <summary>
-##	Do not audit attempts to get
-##	attributes of mail spool files.
+##	Do not audit attempts to get the attributes
+##	of mail spool files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -775,9 +745,8 @@ interface(`mta_dontaudit_getattr_spool_f
 
 #######################################
 ## <summary>
-##	Create specified objects in the
-##	mail spool directory with a
-##	private type.
+##	Create private objects in the
+##	mail spool directory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -811,7 +780,7 @@ interface(`mta_spool_filetrans',`
 
 #######################################
 ## <summary>
-##  Read mail spool files.
+##  Read the mail spool.
 ## </summary>
 ## <param name="domain">
 ##  <summary>
@@ -819,10 +788,10 @@ interface(`mta_spool_filetrans',`
 ##  </summary>
 ## </param>
 #
-interface(`mta_read_spool_files',`
-	gen_require(`
-		type mail_spool_t;
-	')
+interface(`mta_read_spool',`
+    gen_require(`
+        type mail_spool_t;
+    ')
 
 	files_search_spool($1)
 	read_files_pattern($1, mail_spool_t, mail_spool_t)
@@ -830,7 +799,7 @@ interface(`mta_read_spool_files',`
 
 ########################################
 ## <summary>
-##	Read and write mail spool files.
+##	Read and write the mail spool.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -845,13 +814,14 @@ interface(`mta_rw_spool',`
 
 	files_search_spool($1)
 	allow $1 mail_spool_t:dir list_dir_perms;
-	allow $1 mail_spool_t:file rw_file_perms;
-	allow $1 mail_spool_t:lnk_file read_lnk_file_perms;
+	allow $1 mail_spool_t:file setattr_file_perms;
+	manage_files_pattern($1, mail_spool_t, mail_spool_t)
+	read_lnk_files_pattern($1, mail_spool_t, mail_spool_t)
 ')
 
 #######################################
 ## <summary>
-##	Create, read, and write mail spool files.
+##	Create, read, and write the mail spool.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -866,13 +836,14 @@ interface(`mta_append_spool',`
 
 	files_search_spool($1)
 	allow $1 mail_spool_t:dir list_dir_perms;
-	manage_files_pattern($1, mail_spool_t, mail_spool_t)
-	allow $1 mail_spool_t:lnk_file read_lnk_file_perms;
+	create_files_pattern($1, mail_spool_t, mail_spool_t)
+	write_files_pattern($1, mail_spool_t, mail_spool_t)
+	read_lnk_files_pattern($1, mail_spool_t, mail_spool_t)
 ')
 
 #######################################
 ## <summary>
-##	Delete mail spool files.
+##	Delete from the mail spool.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -891,8 +862,7 @@ interface(`mta_delete_spool',`
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	mail spool content.
+##	Create, read, write, and delete mail spool files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -911,45 +881,9 @@ interface(`mta_manage_spool',`
 	manage_lnk_files_pattern($1, mail_spool_t, mail_spool_t)
 ')
 
-#######################################
-## <summary>
-##	Create specified objects in the
-##	mail queue spool directory with a
-##	private type.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-## <param name="private type">
-##	<summary>
-##	The type of the object to be created.
-##	</summary>
-## </param>
-## <param name="object">
-##	<summary>
-##	The object class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
-##	<summary>
-##	The name of the object being created.
-##	</summary>
-## </param>
-#
-interface(`mta_queue_filetrans',`
-	gen_require(`
-		type mqueue_spool_t;
-	')
-
-	files_search_spool($1)
-	filetrans_pattern($1, mqueue_spool_t, $2, $3, $4)
-')
-
 ########################################
 ## <summary>
-##	Search mail queue directories.
+##	Search mail queue dirs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -968,7 +902,7 @@ interface(`mta_search_queue',`
 
 #######################################
 ## <summary>
-##	List mail queue directories.
+##	List the mail queue.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -981,13 +915,13 @@ interface(`mta_list_queue',`
 		type mqueue_spool_t;
 	')
 
-	files_search_spool($1)
 	allow $1 mqueue_spool_t:dir list_dir_perms;
+	files_search_spool($1)
 ')
 
 #######################################
 ## <summary>
-##	Read mail queue files.
+##	Read the mail queue.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -1000,14 +934,14 @@ interface(`mta_read_queue',`
 		type mqueue_spool_t;
 	')
 
-	files_search_spool($1)
 	read_files_pattern($1, mqueue_spool_t, mqueue_spool_t)
+	files_search_spool($1)
 ')
 
 #######################################
 ## <summary>
 ##	Do not audit attempts to read and
-##	write mail queue content.
+##	write the mail queue.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -1027,7 +961,7 @@ interface(`mta_dontaudit_rw_queue',`
 ########################################
 ## <summary>
 ##	Create, read, write, and delete
-##	mail queue content.
+##	mail queue files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -1047,6 +981,41 @@ interface(`mta_manage_queue',`
 
 #######################################
 ## <summary>
+##	Create private objects in the
+##	mqueue spool directory.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+## <param name="private type">
+##	<summary>
+##	The type of the object to be created.
+##	</summary>
+## </param>
+## <param name="object">
+##	<summary>
+##	The object class of the object being created.
+##	</summary>
+## </param>
+## <param name="name" optional="true">
+##	<summary>
+##	The name of the object being created.
+##	</summary>
+## </param>
+#
+interface(`mta_spool_filetrans_queue',`
+	gen_require(`
+		type mqueue_spool_t;
+	')
+
+	files_search_spool($1)
+	filetrans_pattern($1, mqueue_spool_t, $2, $3, $4)
+')
+
+#######################################
+## <summary>
 ##	Read sendmail binary.
 ## </summary>
 ## <param name="domain">
@@ -1055,6 +1024,7 @@ interface(`mta_manage_queue',`
 ##	</summary>
 ## </param>
 #
+# cjp: added for postfix
 interface(`mta_read_sendmail_bin',`
 	gen_require(`
 		type sendmail_exec_t;
@@ -1065,8 +1035,8 @@ interface(`mta_read_sendmail_bin',`
 
 #######################################
 ## <summary>
-##	Read and write unix domain stream
-##	sockets of all base mail domains.
+##	Read and write unix domain stream sockets
+##	of user mail domains.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -1081,3 +1051,177 @@ interface(`mta_rw_user_mail_stream_socke
 
 	allow $1 user_mail_domain:unix_stream_socket rw_socket_perms;
 ')
+
+########################################
+## <summary>
+##	Type transition files created in calling dir 
+##	to the mail address aliases type.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+## <param name="domain">
+##	<summary>
+##	Directory to transition on.
+##	</summary>
+## </param>
+#
+interface(`mta_filetrans_aliases',`
+	gen_require(`
+		type etc_aliases_t;
+	')
+
+	filetrans_pattern($1, $2, etc_aliases_t, file)
+')
+
+######################################
+## <summary>
+##	ALlow domain to read mail content in the homedir
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`mta_read_home',`
+	gen_require(`
+		type mail_home_t;
+	')
+
+	userdom_search_user_home_dirs($1)
+	read_files_pattern($1, mail_home_t, mail_home_t)
+
+	ifdef(`distro_redhat',`
+		userdom_search_admin_dir($1)
+	')
+')
+
+####################################
+## <summary>
+##      ALlow domain to read mail content in the homedir
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
+#
+interface(`mta_read_home_rw',`
+        gen_require(`
+                type mail_home_rw_t;
+        ')
+
+        userdom_search_user_home_dirs($1)
+        read_files_pattern($1, mail_home_rw_t, mail_home_rw_t)
+		read_lnk_files_pattern($1, mail_home_rw_t, mail_home_rw_t)
+
+        ifdef(`distro_redhat',`
+                userdom_search_admin_dir($1)
+        ')
+')
+
+####################################
+## <summary>
+##      Allow domain to manage mail content in the homedir
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
+#
+interface(`mta_manage_home_rw',`
+        gen_require(`
+                type mail_home_rw_t;
+        ')
+
+        userdom_search_user_home_dirs($1)
+	userdom_search_admin_dir($1)
+	manage_files_pattern($1, mail_home_rw_t, mail_home_rw_t)
+	manage_dirs_pattern($1, mail_home_rw_t, mail_home_rw_t)
+	manage_lnk_files_pattern($1, mail_home_rw_t, mail_home_rw_t)
+	userdom_user_home_dir_filetrans($1, mail_home_rw_t, dir, "Maildir")
+
+        ifdef(`distro_redhat',`
+                userdom_search_admin_dir($1)
+		userdom_admin_home_dir_filetrans($1, mail_home_rw_t, dir, "Maildir")
+        ')
+')
+
+########################################
+## <summary>
+##	create mail content in the  in the /root directory
+##	with an correct label.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`mta_filetrans_admin_home_content',`
+	gen_require(`
+		type mail_home_t;
+		type mail_home_rw_t;
+	')
+
+	userdom_admin_home_dir_filetrans($1, mail_home_t, file, "dead.letter")
+	userdom_admin_home_dir_filetrans($1, mail_home_t, file, ".mailrc")
+	userdom_admin_home_dir_filetrans($1, mail_home_t, file, ".forward")
+	userdom_admin_home_dir_filetrans($1, mail_home_rw_t, dir, "Maildir")
+	userdom_admin_home_dir_filetrans($1, mail_home_rw_t, dir, ".maildir")
+	userdom_admin_home_dir_filetrans($1, mail_home_rw_t, file, ".esmtp_queue")
+	userdom_admin_home_dir_filetrans($1, mail_home_rw_t, dir, ".esmtp_queue")
+')
+
+########################################
+## <summary>
+##	Transition to mta named home content
+## </summary>
+## <param name="domain">
+##	<summary>
+##      Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`mta_filetrans_home_content',`
+	gen_require(`
+		type mail_home_t;
+		type mail_home_rw_t;
+	')
+
+	userdom_user_home_dir_filetrans($1, mail_home_t, file, ".mailrc")
+	userdom_user_home_dir_filetrans($1, mail_home_t, file, "dead.letter")
+	userdom_user_home_dir_filetrans($1, mail_home_t, file, ".forward")
+	userdom_user_home_dir_filetrans($1, mail_home_rw_t, dir, "Maildir")
+	userdom_user_home_dir_filetrans($1, mail_home_rw_t, dir, ".maildir")
+	userdom_user_home_dir_filetrans($1, mail_home_rw_t, file, ".esmtp_queue")
+	userdom_user_home_dir_filetrans($1, mail_home_rw_t, dir, ".esmtp_queue")
+')
+
+########################################
+## <summary>
+##	Transition to mta named content
+## </summary>
+## <param name="domain">
+##	<summary>
+##      Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`mta_filetrans_named_content',`
+	gen_require(`
+		type etc_aliases_t;
+		type etc_mail_t;
+	')
+
+	#filetrans_pattern($1, etc_mail_t, etc_aliases_t, { dir file })
+	mta_etc_filetrans_aliases($1, "aliases")
+	mta_etc_filetrans_aliases($1, "aliases.db")
+	mta_etc_filetrans_aliases($1, "aliasesdb-stamp")
+	mta_filetrans_home_content($1)
+	mta_filetrans_admin_home_content($1)
+')
